<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-col :span="18">
        <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">更新</el-button>
      </el-col>
    </div>

    <el-table :data="tableData"
              style="width: 100%"
              @selection-change="handleSelectionChange"
              :default-sort="{prop: 'sort', order: 'descending'}">

      <el-table-column label="ID" width="100" align="left">
        <template slot-scope="scope">
          <span>{{ scope.row.uid }}</span>
        </template>
      </el-table-column>

      <el-table-column label="Key" width="100" align="left">
        <template slot-scope="scope">
          <span>{{ scope.row.appKey }}</span>
        </template>
      </el-table-column>

      <el-table-column label="标题"  width="200" align="left">
        <template slot-scope="scope">
          <span>{{ scope.row.title }}</span>
        </template>
      </el-table-column>
      <el-table-column label="说明" width="300" align="left">
        <template slot-scope="scope">
          <span>{{ scope.row.content }}</span>
        </template>
      </el-table-column>
      <el-table-column label="值"  width="200" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.value }}</span>
        </template>
      </el-table-column>

      <el-table-column label="更新时间" style="width: 30%" align="center" prop="updateTime" sortable="custom" :sort-by="['updateTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.updateTime }}</span>
        </template>
      </el-table-column>

      <el-table-column label="操作" style="width: 10%" align="center">
        <template slot-scope="scope">
          <el-button @click="handleEdit(scope.row)" type="primary" size="small">编辑</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>

    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="dialogFormVisible" :before-close="handleClose" width="30%">
      <el-form :model="form" :rules="rules" ref="form">
        <el-form-item label="ID" v-if="form.uid" :label-width="formLabelWidth">
          <span>{{form.uid}}</span>
        </el-form-item>
        <el-form-item label="标题" :label-width="formLabelWidth" prop="title">
          <el-input v-model="form.title" style="width: 80%"></el-input>
        </el-form-item>
        <el-form-item label="说明" :label-width="formLabelWidth" prop="content">
          <el-input v-model="form.content" style="width: 80%"></el-input>
        </el-form-item>
        <el-form-item label="值" :label-width="formLabelWidth" prop="value">
          <el-input v-model="form.value" style="width: 80%"></el-input>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="handleClose">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  getSettingList,
  editSetting,
} from "@/api/booksSetting";
export default {
  data() {
    return {
      multipleSelection: [], //多选，用于批量删除
      tableData: [],
      keyword: "",
      currentPage: 1,
      pageSize: 40,
      total: 0, //总数量
      title: "漫画設定編輯",
      dialogFormVisible: false, //控制弹出框
      formLabelWidth: "120px",
      isEditForm: false,
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
      form: {
        title: "",
        content: "",
        value: "",
        sort: 0,
      },
      rules: {
        title: [
          {required: true, message: '标题不能为空', trigger: 'blur'},
          {min: 0, max: 200, message: '最多输入200个字'},
        ],
        content: [
          {min: 0, max: 200, message: '最多输入200个字'},
        ],
      }
    };
  },
  created() {
    this.settingList();
  },
  methods: {

    settingList: function() {
      var params = {};
      params.keyword = this.keyword;
      params.currentPage = this.currentPage;
      params.pageSize = this.pageSize;
      params.orderByDescColumn = this.orderByDescColumn
      params.orderByAscColumn = this.orderByAscColumn
      getSettingList(params).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        content: null,
        clickCount: 0,
        sort: 0
      };
      return formObject;
    },
    handleFind: function() {
      this.currentPage = 1
      this.settingList();
    },

    handleEdit: function(row) {
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.form = row;
    },
    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.settingList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.settingList();
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log('校验失败')
          return;
        } else {
          if (this.isEditForm) {
            editSetting(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.settingList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          }
        }
      })
    },


    // 改变多选
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleClose(){
      this.dialogFormVisible = false;
      this.settingList();
    },
  }
};
</script>
